; Omnicalc v1.10
; (C) 2002-2003 Michael Vincent.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Hook_Key:
	;Key hook for _getkey
	add a,e
	ld e,a
	cp kMode
	call z,Hook_Key_Mode
	cp kAppsMenu
	call z,Hook_Key_Apps
	ld a,e
	cp 91h
	call z,Hook_Key_Prgm_Second
	cp k5
	call z,Hook_Key_Custom_Second
	cp kPrgm
	jp nz,Hook_Key_Other
	ld a,(menucurrent)
	cp 03h
	jp z,Hook_Key_Prgm
	cp 2Ah
	jp z,Hook_Key_Prgm
	ld a,kPrgm
	ret
Hook_Key_Apps:
	in a,(4)
	bit 3,a
	jr nz,Hook_Key_Apps_AppsReturn
	;On+Apps pressed. Now check for MirageOS
	ld hl,MirageOS
	rst 20h
	B_CALL FindApp
	jr c,Hook_Key_Apps_AppsReturn
	;Run MirageOS
	ld hl,MirageOS+1
	ld de,progToEdit
	ld bc,8
	ldir
	B_CALL CloseEditEqu
	B_CALL ExecuteApp
MirageOS:
	DB AppObj,"MirageOS"
Hook_Key_Apps_AppsReturn:
	ld a,kAppsMenu
	ld e,a
	ret
 INCLUDE "vcalc.asm"
Hook_Key_Other:
	cp kLog
	jp z,Hook_Key_Base
	cp kMath
	jp z,Hook_Key_Math
	cp kVars
	jp z,Hook_Key_Vars
	cp 0Dh
	jp z,Hook_Key_Entry
	cp kLinkIO
	jp z,Hook_Key_Link
	cp kDel
	jp z,Hook_Key_MemoryDel
	cp 0ACh
	jp z,Hook_Key_CheckForModeScreen
	ld c,a
	ld a,(menucurrent)
	cp 0Ch	;Memory menu
	jp z,Hook_Key_MemoryMenu
	cp 45h
	jr z,Hook_Key_Catalog
Hook_Key_CRet:
	ld a,c
Hook_Key_MemoryReturnOK:
	or a
	ret
Hook_Key_Catalog_AlphaCheck:
	ld e,c
	ld hl,Hook_Key_Catalog_Alphas
	ld bc,8
	cpir
	ld a,e
	jr nz,Hook_Key_MemoryReturnOK
	ld c,e
	ld de,7
	add hl,de
	ld a,(hl)
	jr Hook_Key_Catalog_AlphaNumbersGO
Hook_Key_Catalog_Alphas:
	DB kCapO,kCapP,kCapT,kCapU,kCapV,kCapY,kCapZ,kTheta
	DB 6,7,3,4,5,0,1,2
Hook_Key_Catalog:
	ld a,c
	cp k1
	jr c,Hook_Key_Catalog_AlphaCheck
	cp k9
	jr nc,Hook_Key_Catalog_AlphaCheck
	sub k1
Hook_Key_Catalog_AlphaNumbersGO:
	ld d,a
	in a,(4)
	bit 3,a
	jr nz,Hook_Key_CRet
	ld a,(localLanguage)
	cp LANG_ENGLISH
	jr nz,Hook_Key_CRet
	ld a,d
	push af
	;1-8 pressed with On
	ld hl,CatalogAppVar
	rst 20h
	B_CALL ChkFindSym
	jp c,Parse_Error_Undefined
	ld a,b
	or a
	jp nz,Parse_Error_Undefined
	ex de,hl
	inc hl
	inc hl
	pop af
	add a,a
	ld d,0
	ld e,a
	add hl,de
	;HL is where to insert
	push hl
	ld hl,CatalogKeyLoader
	ld de,ramCode
	ld bc,CatalogKeyLoader_End-CatalogKeyLoader
	ldir
	call ramCode
	pop hl
	ld a,e
	cp 0FCh
	jr z,Catalog_Insert_Two
	cp 0FEh
	jr z,Catalog_Insert_Two
	cp 0FFh
	jr z,Catalog_Insert_TwoDec
	ld (hl),d
	xor a
	ret
Catalog_Insert_TwoDec:
	dec e
Catalog_Insert_Two:
	ld (hl),e
	inc hl
	ld (hl),d
	xor a
	ret
CatalogKeyLoader:
	in a,(6)
	push af
	ld a,07h
	out (6),a
	ld hl,(CatalogCurrent)
	ld e,(hl)
	inc hl
	ld d,(hl)
	pop af
	out (6),a
	ret
CatalogKeyLoader_End:
Hook_Key_MemoryDel:
	ld a,(cxCurApp)
	cp cxErase
	jr nz,Hook_Key_MemoryDel_Del
	call GetRealSettings
	bit 2,(hl)
	jr z,Hook_Key_MemoryDel_Del
	xor a
	ret
Hook_Key_MemoryDel_Del:
	ld a,kDel
	or a
	ret
Hook_Key_MemoryMenu:
	ld a,c
	cp kEnter
	jr z,Hook_Key_MemoryMenu_Enter
	cp k7
	jp nz,Hook_Key_MemoryReturnOK
	call GetRealSettings
	bit 2,(hl)
	jr z,Hook_Key_MemoryMenu_7No
	xor a
	ret
Hook_Key_MemoryMenu_7No:
	ld a,k7
	or a
	ret
Hook_Key_MemoryMenu_Enter:
	call GetRealSettings
	bit 2,(hl)
	jr z,Hook_Key_MemoryMenu_EnterNo
	ld a,(85E0h)	;Check menu number
	cp 6
	jr nz,Hook_Key_MemoryMenu_EnterNo
	xor a
	ret
Hook_Key_MemoryMenu_EnterNo:
	ld a,kEnter
	or a
	ret
Hook_Key_CheckForModeScreen:
	ld a,(cxCurApp)
	cp cxMode
	jr nz,Hook_Key_CheckForModeScreenNo
	call GetRealSettings
	bit 2,(hl)
	jr z,Hook_Key_CheckForModeScreenNo
	xor a
	ret
Hook_Key_CheckForModeScreenNo:
	ld a,0ACh
	or a
	ret
Hook_Key_Prgm_Second:
	ld a,(tokenHookPtr+3)
	cp 3
	jr nc,Hook_Key_Prgm_Second_Real
	dec a
	jr nz,Hook_Key_Prgm_Second_No
	pop af
	ld a,2
	ld (tokenHookPtr+3),a
	ld a,kReal
	ld (keyExtend),a
	ld a,0FCh
	or a
	ret
Hook_Key_Prgm_Second_Real:
	;(rawkeyhookptr+3)
	cp 4
	jr z,Hook_Key_Prgm_Second_Real_Second
	cp 5
	jr z,Hook_Key_Prgm_Second_Real_Third
	cp 6
	jr z,Hook_Key_Prgm_Second_Real_Fourth
	ld a,4
	ld (tokenHookPtr+3),a
	ld a,12h
	ld (kbdscancode),a
	ld a,kReal
	ld (keyExtend),a
	ld a,0FCh
	or a
	ret
DivideBy10:
	ld c,-1
Div10loop
	inc c
	sub 10
	jr nc,Div10loop
	add a,10
	ret
Hook_Key_Prgm_Second_Real_Second:
	ld a,5
	ld (tokenHookPtr+3),a
	ld a,12h
	ld (kbdscancode),a
	ld a,(rawKeyHookPtr+3)
	sub 0CFh
	call DivideBy10
	ld a,c
	add a,k0
	or a
	ret
Hook_Key_Prgm_Second_Real_Third:
	ld a,12h
	ld (kbdscancode),a
	ld a,6
	ld (tokenHookPtr+3),a
	ld a,(rawKeyHookPtr+3)
	sub 0CFh
	call DivideBy10
	add a,k0
	or a
	ret
Hook_Key_Prgm_Second_Real_Fourth:
	xor a
	ld (tokenHookPtr+3),a
	ld a,kComma
	or a
	ret
Hook_Key_Prgm_Second_No:
	ld a,91h
	or a
	ret
Hook_Key_Prgm_FirstTime:
Hook_Key_Prgm:
	; (tokenhookptr+3) tells us 1 if a token was inserted, 2 if second time.
	; (rawkeyhookptr+3) tells us which token (last byte) to insert
	call Menu
	ld (rawkeyhookptr+3),a
	ld a,1
	ld (tokenHookPtr+3),a
	ld a,12h
	ld (kbdscancode),a
	ld a,kClear
	or a
	res cmdVirgin,(iy+cmdFlags)
	ret
Menu:
	ld hl,FunctionsMenu
	res indicrun,(iy+indicflags)
	res apptextsave,(iy+appflags)
	;If 3 columns columns go 0-2
	;If 5 rows rows would go 0-4
	xor a
	ld (cur_row),a
	ld (cur_column),a
	ld a,(hl)	;Get columns
	dec a
	ld (endcolumn),a
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,(de)
	dec a
	ld (endrow),a
	call Menu_Display
Menu_Loop:
	B_CALL GetKey
	cp kDown
	jp z,Menu_Down
	cp kUp
	jp z,Menu_Up
	cp kRight
	jp z,Menu_Right
	cp kLeft
	jp z,Menu_Left
	cp kEnter
	jp z,Menu_Enter
	cp kAdd
	jr z,Menu_Help
	cp kMul
	jp z,Menu_Real_Enter
	cp k1
	call nc,Menu_Number_Maybe
	ld hl,Menu_SpecialKeys
	ld c,(hl)
	inc hl
	ld b,0
	cpir
	jr nz,Menu_Loop
	pop hl
	or a
	ret
Menu_Number_Maybe:
	cp k9+1
	ret nc
	;We have 0-9
	push af
	ld hl,FunctionsMenu+1
	ld a,(cur_column)
	add a,a
	ld b,0
	ld c,a
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	pop af
	ld c,(hl)
	sub k1
	cp c
	ret nc
	inc hl
	inc a
	ld b,a
Menu_Number_Search:
	push bc
	xor a
	ld bc,-1
	cpir
	pop bc
	djnz Menu_Number_Search
	ld a,(hl)
	pop hl
	ret
Menu_Help:
	ld hl,FunctionsMenu+1
	ld a,(cur_column)
	add a,a
	ld b,0
	ld c,a
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	inc hl
	;HL now points to start of menu data
	ld a,(cur_row)
	inc a
	ld b,a
Menu_Help_Search:
	push bc
	xor a
	ld bc,-1
	cpir
	pop bc
	djnz Menu_Help_Search
	ld a,(hl)
	sub 0E3h
	add a,a
	ld hl,Menu_Help_Table
	ld d,0
	ld e,a
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;HL points to help stuff
	push hl
	B_CALL ClrLCDFull
	ld de,0
	ld (currow),de
	pop hl
	call PutScreen
Menu_Help_Pause:
	ei
	halt
	B_CALL GetCSC
	or a
	jr z,Menu_Help_Pause
	call Menu_Display
	jp Menu_Loop
Menu_Help_Table:
	DW Menu_Help_Sprite
	DW Menu_Help_Roman
	DW Menu_Help_Simp
	DW Menu_Help_Factor
	DW Menu_Help_Gamma
	DW Menu_Help_Base
	DW Menu_Help_LinkGet
	DW Menu_Help_LinkSend
	DW Menu_Help_Modulo
	DW Menu_Help_Constant
	DW Menu_Help_Subfactorial
	DW Menu_Help_Program
	DW Menu_Help_Program
Menu_Help_Sprite:
	DB "sprite(pic #,spr"
	DB "ite X,sprite Y,s"
	DB "prite width,spri"
	DB "te height,dest X"
	DB ",dest Y"
	DB 1,1
	DB "Press any key",0
Menu_Help_Roman:
	DB "Rom",5,"Dec(string)",1
	DB 1
	DB "string is Roman",1
	DB "Numerals. Ex:",1
	DB "Rom",5,"Dec(",lquote,"MCMLX",lquote,")",1
	DB 1
	DB "Press any key",0
Menu_Help_Simp:
	DB "simp",10h,"(number)",1
	DB 1
	DB "Simplifies the r"
	DB "adical of number"
	DB "(a positive inte"
	DB "ger.)",1,1
	DB "Press any key",0
Menu_Help_Factor:
	DB "factor(number)",1
	DB 1
	DB "Returns a list o"
	DB "f factors for nu"
	DB "mber (positive i"
	DB "nteger)",1,1
	DB "Press any key",0
Menu_Help_Gamma:
	DB "gamma(number)",1
	DB 1
	DB "number is nonneg"
	DB "ative. Returns",1
	DB "gamma of number.",1,1
	DB "Press any key",0
Menu_Help_Base:
	DB "baseInput(",34,"n",34,",b,"
	DB 0C1h,"new b]",1
	DB "Inputs integer",1
	DB "n, where n is in"
	DB "base b. Optional"
	DB "ly converts to",1
	DB "new b.",1
	DB "Press any key",0
Menu_Help_LinkGet:
	DB "linkGet(n)",1
	DB 1
	DB "Gets byte from l"
	DB "ink port. n=0 or"
	DB "(n=1 to wait for"
	DB "ever for byte).",1
	DB "-1 if failed.",1
	DB "Press any key",0
Menu_Help_LinkSend:
	DB "linkSend(byte)",1
	DB 1
	DB "Sends byte (0-25"
	DB "5) through link "
	DB "port. Returns 0 "
	DB "on work, -1 on  "
	DB "failure",1
	DB "Press any key",0
Menu_Help_Modulo:
	DB "mod(n1,n2)",1
	DB 1
	DB "Returns the",1
	DB "remainder of",1
	DB "n1/n2.",1,1
	DB 1
	DB "Press any key",0
Menu_Help_Constant:
	DB "const(string)",1
	DB 1
	DB "Returns a",1
	DB "constant like",1
	DB "NA,K,CC,EC,RC,",1
	DB "GC,G,ME,MP,MN,",1
	DB "H,C,U",1
	DB "Press any key",0
Menu_Help_Subfactorial:
	DB "!n(number)",1
	DB 1
	DB "Returns the",1
	DB "derangements of "
	DB "a list with",1
	DB "number elements.",1
	DB "Press any key",0
Menu_Help_Program:
	DB "Please refer to",1
	DB "the Omnicalc",1
	DB "manual for help",1
	DB "with this.",1,1,1,1
	DB "Press any key",0
PutScreen:
	ld a,(hl)
	inc hl
	or a
	ret z
	cp 1
	jr z,PutScreen_NewLine
	B_CALL PutC
	jr PutScreen
PutScreen_NewLine:
	xor a
	ld (curcol),a
	ld a,(currow)
	inc a
	ld (currow),a
	jr PutScreen
Menu_Real_Enter:
	pop hl
	call Menu_Enter
	ld (rawkeyhookptr+3),a
	ld a,3
	ld (tokenHookPtr+3),a
	ld a,12h
	ld (kbdscancode),a
	ld a,kClear
	or a
	res cmdVirgin,(iy+cmdFlags)
	ret
Menu_Enter:
	ld hl,FunctionsMenu+1
	ld a,(cur_column)
	add a,a
	ld b,0
	ld c,a
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	inc hl
	;HL now points to start of menu data
	ld a,(cur_row)
	inc a
	ld b,a
Menu_Enter_Search:
	push bc
	xor a
	ld bc,-1
	cpir
	pop bc
	djnz Menu_Enter_Search
	ld a,(hl)
	ret
Menu_Left:
	ld a,(cur_column)
	or a
	jr z,Menu_Left_Right
	dec a
	ld (cur_column),a
	jr Menu_Right_Go
Menu_Left_Right:
	ld a,(endcolumn)
	ld (cur_column),a
	jr Menu_Right_Go
Menu_Right:
	ld a,(endcolumn)
	ld b,a
	ld a,(cur_column)
	cp b
	jr z,Menu_Right_Left
	inc a
	ld (cur_column),a
Menu_Right_Go:
	ld hl,FunctionsMenu+1
	add a,a
	ld b,0
	ld c,a
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld a,(hl)
	dec a
	ld (endrow),a
	xor a
	ld (cur_row),a
	call Menu_Display
	jp Menu_Loop
Menu_Right_Left:
	xor a
	ld (cur_column),a
	jr Menu_Right_Go
Menu_Up:
	ld a,(cur_row)
	or a
	jr z,Menu_Up_Bottom
	dec a
	ld (cur_row),a
	call Menu_Refresh
	jp Menu_Loop
Menu_Up_Bottom:
	ld a,(endrow)
	ld (cur_row),a
	call Menu_Refresh
	jp Menu_Loop
Menu_Down:
	ld a,(endrow)
	ld b,a
	ld a,(cur_row)
	cp b
	jr z,Menu_Down_Top
	inc a
	ld (cur_row),a
	call Menu_Refresh
	jp Menu_Loop
Menu_Down_Top:
	xor a
	ld (cur_row),a
	call Menu_Refresh
	jp Menu_Loop
Menu_Display:
	ld de,0
	ld (currow),de
	B_CALL ClrLCDFull
	ld hl,FunctionsMenu
	ld a,(hl)
	add a,a
	inc a
	ld b,0
	ld c,a
	add hl,bc
	ld a,(FunctionsMenu)
	ld b,a
	ld c,0
Menu_Display_Top_Loop:
	push bc
	ld a,(cur_column)
	cp c
	call z,SetInverse
	call putstr
	call ResInverse
	ld a,20h
	B_CALL PutC
	pop bc
	inc c
	djnz Menu_Display_Top_Loop
	;Now display rows (1:2:3: et cetera)
Menu_Refresh:
	ld hl,FunctionsMenu+1
	ld a,(cur_column)
	add a,a
	ld b,0
	ld c,a
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	inc hl
	ld de,0*256+1
	ld (currow),de
	ld c,0
	ld a,(endrow)
	inc a
	ld b,a
Menu_Display_Row_Loop:
	push bc
	ld a,(cur_row)
	cp c
	jr nz,Menu_Display_Row_Normal
	set textInverse,(iy+textFlags)
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,(hl)
	B_CALL PutC
	inc hl
	res textInverse,(iy+textFlags)
Menu_Display_Row_Normal:
	call putstr
	inc hl
	push hl
	ld hl,currow
	inc (hl)
	inc hl
	ld (hl),0
	pop hl
	pop bc
	inc c
	djnz Menu_Display_Row_Loop
	ret
SetInverse:
	set textInverse,(iy+textFlags)
	ret
ResInverse:
	res textInverse,(iy+textFlags)
	ret
Menu_SpecialKeys:
	DB 29
	DB kClear,kAppsMenu,kPrgm,kZoom,kDraw,kSPlot,kStat,kMath
	DB kTest,kChar,kVars,kMem,kMatrix,kDist,kAngle,kList,kCalc
	DB kCatalog,kgraph,kMode,kWindow,kYequ,kTable,kTblSet
	DB	kStatP,kFormat,kTrace,kQuit
FunctionsMenu:
	;Format:
	;Number of columns
	DB 3
	DW Menu_Prgm
	DW Menu_Math
	DW Menu_Misc
	DB "PRGM",0
	DB "MATH",0
	DB "MISC",0
Menu_Prgm:
	DB 1
	DB "1:sprite(",0,0E3h
Menu_Math:
	DB 7
	DB "1:!n(",0,0EDh
	DB "2:baseInput(",0,0E8h
	DB "3:const(",0,0ECh
	DB "4:factor(",0,0E6h
	DB "5:gamma(",0,0E7h
	DB "6:mod(",0,0EBh
	DB "7:simp",10h,"(",0,0E5h
Menu_Misc:
	DB 4
	DB "1:linkGet(",0,0E9h
	DB "2:linkSend(",0,0EAh
	DB "3:RestoreMem(",0,0EFh
	DB "4:Rom",5,"Dec(",0,0E4h
Hook_Key_Link:
	ld hl,(progPtr)
Hook_Key_Link_SearchLoop:
	ld bc,(pTemp)
	or a
	sbc hl,bc
	jr c,Hook_Key_Link_Done
	jr z,Hook_Key_Link_Done
	add hl,bc
	ld a,(hl)
	cp 5
	jr nz,Hook_Key_Link_NextVariable
	dec hl
	dec hl
	ld (hl),0
	inc hl
	inc hl
Hook_Key_Link_NextVariable:
	ld de,-6
	add hl,de
	ld d,0
	ld e,(hl)
	inc e
	or a
	sbc hl,de
	jr Hook_Key_Link_SearchLoop
Hook_Key_Link_Done:
	ld a,kLinkIO
	or a
	ret
Hook_Key_Entry:
	ld a,(cxCurApp)
	cp 40h
	jp nz,Hook_Key_Entry_Keep
	ld a,(menucurrent)
	or a
	jp nz,Hook_Key_Entry_Keep
	call GetRealSettings
	bit 3,(hl)
	jp z,Hook_Key_Entry_Keep
	;Now check if Rcl mode active
	ld hl,textshadow+70h
	ld de,Hook_Key_Entry_Rcl
	ld b,4
	call CompareStrings
	jp z,Hook_Key_Entry_Keep
	;We are good...
	ld hl,9872h
	B_CALL SaveDisp
	res indicrun,(iy+indicflags)
	res apptextsave,(iy+appflags)
	B_CALL CursorOff
	ld hl,Entries_Program
	rst 20h
	B_CALL ChkFindSym
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld a,b
	or c
	jp z,Hook_Key_Entry_Cancel
	dec hl
	inc bc
	inc bc
	ld de,entrieslist
	ldir
	ld a,(numLastEntries)
	inc a
	ld (numentries),a
	;Copy entries over
	ld a,(numLastEntries)
	or a
	jr z,Entries_SkipFirstCopy
	ld b,a
	ld hl,lastEntryStk
	;DE is where to copy
Entries_FirstCopy:
	push bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc bc
	inc bc
	dec hl
	ldir
	pop bc
	djnz Entries_FirstCopy
Entries_SkipFirstCopy:
	ld hl,(currow)
	ld (originalcur),hl
	res appTextSave,(iy+appFlags)
	B_CALL ClrLCDFull
	ld hl,0
	ld (currow),hl
	ld hl,Entries_Title
	set textInverse,(iy+textFlags)
	call putstr
	res textInverse,(iy+textFlags)
	ld a,(numentries)
	ld b,a
	dec a
	ld (enditem),a
	xor a
	ld (curitem),a
	ld (menutop),a
	inc a
	ld (itemrow),a
	ld a,b
	cp 8
	jr c,Entries_InitialMenuOK
	ld b,7
Entries_InitialMenuOK:
	ld hl,0*256+1
	ld (currow),hl
	ld hl,entrieslist
	ld de,Entries_List
Entries_InitialMenu:
	push bc
	push hl
	ex de,hl
	ld a,(currow)
	ld b,a
	ld a,(itemrow)
	cp b
	jr nz,Entries_InitialMenu_SkipHighlight
	set textInverse,(iy+textFlags)
Entries_InitialMenu_SkipHighlight:
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,(hl)
	B_CALL PutC
	res textInverse,(iy+textFlags)
	inc hl
	ex de,hl
	pop hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	;BC is length, HL start of entry
	push de
	call Entries_DisplayEntry
	pop de
	xor a
	ld (curcol),a
	ld a,(currow)
	inc a
	ld (currow),a
	pop bc
	djnz Entries_InitialMenu
	ld a,(numentries)
	cp 8
	jr c,Entries_InitialMenu_SkipArrow
	ld hl,1*256+7
	ld (currow),hl
	ld a,LdownArrow
	B_CALL PutMap
Entries_InitialMenu_SkipArrow:
Entries_Loop:
	B_CALL GetKey
	cp kDown
	jp z,Entries_MoveDown
	cp kUp
	jp z,Entries_MoveUp
	cp kEnter
	jr z,Entries_Enter
	cp kClear
	jp z,Entries_Exit
	cp 40h
	jp z,Entries_Exit
	cp k0
	jr z,Entries_0
	cp k1
	jr c,Entries_Loop
	cp k9+1
	jr nc,Entries_NotNumeric
	sub k1
	ld b,a
	ld a,(enditem)
	cp b
	jr c,Entries_Loop
	ld a,b
	ld (curitem),a
	jr Entries_Enter
Entries_NotNumeric:
	cp 9Ah
	jr c,Entries_Loop
	cp 0B4h
	jr nc,Entries_Loop
	sub 9Ah-10
	ld b,a
	ld a,(enditem)
	cp b
	jr c,Entries_Loop
	ld a,b
	ld (curitem),a
	jr Entries_Enter
Entries_0:
	sub k0-9
	ld (curitem),a
Entries_Enter:
	ld hl,9872h
	ld b,64
	B_CALL RestoreDisp
	ld de,(originalcur)
	ld (currow),de
Entries_Enter_MoveBack:
	ld hl,(editTop)
	ld de,(editCursor)
	or a
	sbc hl,de
	jp z,Entries_Enter_Ready
	B_CALL CursorLeft
	jr Entries_Enter_MoveBack
Entries_Enter_Ready:
	;reset
	ld hl,(editTop)
	ld (editCursor),hl
	ld hl,(editBtm)
	ld (editTail),hl
	;now insert
	ld a,(curitem)
	call GetEntry
	;HL is entry
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
Entries_Enter_Insert_Loop:
	push bc
	ld a,(hl)
	B_CALL IsA2ByteTok
	jr z,Entries_Enter_Insert_Two
	ld d,0
	ld e,(hl)
	push hl
	B_CALL BufInsert
	pop hl
	inc hl
	pop bc
	dec bc
	ld a,b
	or c
	jr nz,Entries_Enter_Insert_Loop
	jr Entries_Enter_Display
Entries_Enter_Insert_Two:
	ld d,(hl)
	inc hl
	ld e,(hl)
	push hl
	B_CALL BufInsert
	pop hl
	inc hl
	pop bc
	dec bc
	dec bc
	ld a,b
	or c
	jr nz,Entries_Enter_Insert_Loop
Entries_Enter_Display:
	set apptextsave,(iy+appflags)
	;ld de,(editTop)
	;ld hl,(editCursor)
	;B_CALL DispForward
	B_CALL EraseEOW
Entries_Enter_Display_Loop:
	B_CALL BufLeft
	jr nz,Entries_Enter_Display_Loop
	res cmdVirgin,(iy+cmdFlags)
	res AnsScroll,(iy+ansFlags)
Entries_Enter_Display_Loop2:
	B_CALL CursorDown
	ld hl,(editBtm)
	ld de,(editTail)
	or a
	sbc hl,de
	jr nz,Entries_Enter_Display_Loop2
	jp Hook_Key_Entry_Cancel
	;Display (editTail) to (editCursor) and exit
Entries_Exit:
	ld hl,9872h
	ld b,64
	B_CALL RestoreDisp
	ld de,(originalcur)
	ld (currow),de
	jp Hook_Key_Entry_Cancel
Entries_MoveUp:
	ld a,(enditem)
	or a
	jp z,Entries_Loop
	ld a,(itemrow)
	dec a
	jr z,Entries_MoveUp_Scroll
	ld a,(curitem)
	or a
	jr z,Entries_MoveUp_Bottom
	call Entries_UnselectCurrent
	ld hl,curitem
	dec (hl)
	ld hl,itemrow
	dec (hl)
	call Entries_SelectCurrent
	jp Entries_Loop
Entries_MoveUp_Scroll:
	ld a,(curitem)
	or a
	jr z,Entries_MoveUp_Bottom
	ld hl,menutop
	dec (hl)
	ld hl,curitem
	dec (hl)
	call Entries_DisplayMenu
	call Entries_SelectCurrent
	jp Entries_Loop
Entries_MoveUp_Bottom:
	ld a,(enditem)
	ld (curitem),a
	ld b,6
	sub b
	ld (menutop),a
	ld a,(enditem)
	cp 7
	jr nc,Entries_MoveUp_BottomSkip
	xor a
	ld (menutop),a
Entries_MoveUp_BottomSkip:
	ld a,7
	ld (itemrow),a
	ld a,(enditem)
	cp 7
	jr nc,Entries_MoveUp_BottomSkip2
	inc a
	ld (itemrow),a
Entries_MoveUp_BottomSkip2:
	call Entries_DisplayMenu
	call Entries_SelectCurrent
	jp Entries_Loop
Entries_MoveDown:
	ld a,(enditem)
	or a
	jp z,Entries_Loop
	ld a,(itemrow)
	cp 7
	jr nc,Entries_MoveDown_Scroll
	ld a,(enditem)
	ld b,a
  	ld a,(curitem)
	cp b
	jr z,Entries_MoveDown_Top
	call Entries_UnselectCurrent
	ld hl,curitem
	inc (hl)
	ld hl,itemrow
	inc (hl)
	call Entries_SelectCurrent
	jp Entries_Loop
Entries_MoveDown_Scroll:
	ld a,(enditem)
	ld b,a
	ld a,(curitem)
	cp b
	jr z,Entries_MoveDown_Top
	ld hl,menutop
	inc (hl)
	ld hl,curitem
	inc (hl)
	call Entries_DisplayMenu
	call Entries_SelectCurrent
	jp Entries_Loop
Entries_MoveDown_Top:
	call Entries_UnselectCurrent
	xor a
	ld (menutop),a
	ld (curitem),a
	inc a
	ld (itemrow),a
	call Entries_DisplayMenu
	call Entries_SelectCurrent
	jp Entries_Loop
Entries_DisplayMenu:
	ld bc,0*256+1
	ld (currow),bc
	ld a,(menutop)
	call GetEntry
	;HL points to first menu
	push hl
	ld a,(menutop)
	ld b,a
	ld a,(enditem)
	sub b
	ld b,a
	cp 6
	jr c,Entries_DisplayMenu_Ready
	ld b,7
Entries_DisplayMenu_Ready:
	ld hl,Entries_List
	ld a,(menutop)
	add a,a
	ld d,0
	ld e,a
	add hl,de
	ex de,hl
	pop hl
Entries_DisplayMenu_Loop:
	push bc
	push hl
	ex de,hl
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,(menutop)
	or a
	jr z,Entries_DisplayMenu_Loop_AtTop
	ld a,(currow)
	dec a
	jr nz,Entries_DisplayMenu_Loop_AtTop
	ld a,LupArrow
	jr Entries_DisplayMenu_Loop_ColonOK
Entries_DisplayMenu_Loop_DownArrow:
	ld a,(enditem)
	ld b,a
	ld a,(menutop)
	add a,6
	cp b
	ld a,':'
	jr nc,Entries_DisplayMenu_Loop_ColonOK
	ld a,LdownArrow
	jr Entries_DisplayMenu_Loop_ColonOK
Entries_DisplayMenu_Loop_AtTop:
	ld a,(currow)
	cp 7
	jr z,Entries_DisplayMenu_Loop_DownArrow
	ld a,(hl)
Entries_DisplayMenu_Loop_ColonOK:
	B_CALL PutC
	inc hl
	ex de,hl
	pop hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	push de
	call Entries_DisplayEntry
	pop de
	xor a
	ld (curcol),a
	ld a,(currow)
	inc a
	ld (currow),a
	pop bc
	djnz Entries_DisplayMenu_Loop
	ret
Entries_DisplayEntry:
	;Inputs - BC length, HL entry
	push hl
	add hl,bc
	ld (temphl),hl
	pop hl
Entries_DisplayEntry_Loop:
	ld a,(hl)
	B_CALL IsA2ByteTok
	jr z,Entries_DisplayEntry_LoopTwo
	dec bc
	push bc
	push hl
	B_CALL Get_Tok_Strng
	ld b,a
	ld a,(curcol)
	add a,b
	cp 17
	jr nc,Entries_DisplayEntry_TooLong
	ld hl,OP3
Entries_DisplayEntry_Disp:	
	ld a,(hl)
	inc hl
	B_CALL PutMap
	ld a,(curcol)
	inc a
	ld (curcol),a
	djnz Entries_DisplayEntry_Disp
	pop hl
	inc hl
	pop bc
	ld a,b
	or c
	jr nz,Entries_DisplayEntry_Loop
	B_CALL EraseEOL
	ret
Entries_DisplayEntry_LoopTwo:
	dec bc
	dec bc
	push bc
	push hl
	B_CALL Get_Tok_Strng
	ld b,a
	ld a,(curcol)
	add a,b
	cp 17
	jr nc,Entries_DisplayEntry_TooLong
	ld hl,OP3
Entries_DisplayEntry_DispTwo:
	ld a,(hl)
	inc hl
	B_CALL PutMap
	ld a,(curcol)
	inc a
	ld (curcol),a
	djnz Entries_DisplayEntry_DispTwo
	pop hl
	inc hl
	inc hl
	pop bc
	ld a,b
	or c
	jr nz,Entries_DisplayEntry_Loop
	B_CALL EraseEOL
	ret
Entries_DisplayEntry_TooLong:
	ld a,15
	ld (curcol),a
	ld a,0CEh
	B_CALL PutMap
	pop hl
	pop bc
	ld hl,(temphl)
	ret
GetEntry:
	ld b,a
	ld hl,entrieslist
	or a
	ret z
GetEntryLoop:
	push bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	add hl,bc
	pop bc
	djnz GetEntryLoop
	ret
Entries_SelectCurrent:
	ld a,(curitem)
	add a,a
	ld hl,Entries_List
	ld b,0
	ld c,a
	add hl,bc
	ld a,(itemrow)
	ld (currow),a
	xor a
	ld (curcol),a
	ld a,(hl)
	set textInverse,(iy+textFlags)
	B_CALL PutC
	inc hl
	ld a,(itemrow)
	cp 7
	jr nz,Entries_SelectCurrent_OK
	ld a,(enditem)
	ld b,a
	ld a,(curitem)
	cp b
	jr c,Entries_SelectCurrent_DownArrow
Entries_SelectCurrent_OK:
	ld a,(itemrow)
	dec a
	jr nz,Entries_SelectCurrent_OK2
	ld a,(menutop)
	or a
	jr z,Entries_SelectCurrent_OK2
	ld a,LupArrow
	B_CALL PutC
	res textInverse,(iy+textFlags)
	ret
Entries_SelectCurrent_OK2:
	ld a,(hl)
	B_CALL PutC
	res textInverse,(iy+textFlags)
	ret
Entries_SelectCurrent_DownArrow:
	ld a,LdownArrow
	B_CALL PutC
	res textInverse,(iy+textFlags)
	ret
Entries_UnselectCurrent:
	ld a,(curitem)
	add a,a
	ld hl,Entries_List
	ld b,0
	ld c,a
	add hl,bc
	ld a,(itemrow)
	ld (currow),a
	xor a
	ld (curcol),a
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,(itemrow)
	cp 7
	jr nz,Entries_UnselectCurrent_OK
	ld a,(enditem)
	ld b,a
	ld a,(menutop)
	add a,7
	cp b
	jr c,Entries_UnselectCurrent_DownArrow
Entries_UnselectCurrent_OK:
	ld a,(itemrow)
	dec a
	jr nz,Entries_UnselectCurrent_OK2
	ld a,(menutop)
	or a
	jr z,Entries_UnselectCurrent_OK2
	ld a,LupArrow
	B_CALL PutC
	ret
Entries_UnselectCurrent_OK2:
	ld a,(hl)
	B_CALL PutC
	ret
Entries_UnselectCurrent_DownArrow:
	ld a,LdownArrow
	B_CALL PutC
	ret
Entries_Title:
	DB "ENTRIES:",0
Entries_List:
	DB "1:2:3:4:5:6:7:8:9:0:A:B:C:D:E:F:G:H:I:J:K:L:M:N:O:P:Q:R:S:T:U:V:W:X:Y:Z:"
	DB "a:b:c:d:e:f:g:h:i:j:k:l:m:n:o:p:q:r:s:t:u:v:w:x:y:z:"
Entries_Program:
	DB 5,"#",0
Hook_Key_Entry_Rcl:
	DB "Rcl "
Hook_Key_Entry_Cancel:
	set apptextsave,(iy+appflags)
	B_CALL CursorOn
	xor a
	ret
Hook_Key_Entry_Keep:
	ld a,0Dh
	or a
	ret
SymbolicApp:
	DB AppObj,"Symbolic"
Hook_Key_Math:
	ld a,(menucurrent)
	cp 2Fh
	jr z,Hook_Key_Math_OK
	cp 08h
	jr z,Hook_Key_Math_OK
Hook_Key_Math_Exit_Good:
	ld a,kMath
	or a
	ret
Hook_Key_Math_OK:
	ld hl,SymbolicApp
	rst 20h
	B_CALL FindApp
	jr c,Hook_Key_Math_Exit_Good
	;Symbolic exists, lets go
	push af
	ld hl,SymbolicMenu_Loader
	ld de,9872h
	ld bc,SymbolicMenu_Loader_End-SymbolicMenu_Loader
	ldir
	pop bc
	call 9872h
	;B contains return code
	ld a,b
	cp 0FFh
	jr z,SymbolicMenu_Good
	or a
	ret
SymbolicMenu_Good:
	ld a,e
	ld (rawkeyhookptr+3),a
	ld a,1
	ld (tokenHookPtr+3),a
	ld a,12h
	ld (kbdscancode),a
	ld a,kClear
	or a
	res cmdVirgin,(iy+cmdFlags)
	ret
SymbolicMenu_Loader:
	in a,(6)
	push af
	ld a,b
	out (6),a
	ld hl,(40ACh)
	ld a,h
	or l
	jr z,SymbolicMenu_Loader_Point
	ld de,SymbolicMenu_Loader_Point-SymbolicMenu_Loader+9872h
	push de
	jp (hl)
SymbolicMenu_Loader_Point:
	ld b,a
	pop af
	out (6),a
	ret
SymbolicMenu_Loader_End:
Hook_Key_Vars:
	ld a,(menucurrent)
	cp 0Bh
	jr z,Hook_Key_Vars_OK
	ld a,kVars
	or a
	ret
Hook_Key_Vars_OK:
	res indicrun,(iy+indicflags)
	res apptextsave,(iy+appflags)
	B_CALL ClrLCDFull
	ld hl,0
	ld (currow),hl
	ld hl,CatalogAppVar
	rst 20h
	B_CALL ChkFindSym
	call c,CreateCustomAppVar
	ld a,b
	or a
	jp z,CustomAppVarGood
	B_CALL Arc_Unarc
	B_CALL ChkFindSym
	ld a,b
	or a
	jp nz,ClearAndExit
CustomAppVarGood:
	ex de,hl
	inc hl
	inc hl
	ld b,8
	;Now display menu
	ld de,Entries_List
	xor a
	ld (cur_row),a
Custom_Display_Loop:
	push bc
	push hl
	ex de,hl
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,(hl)
	B_CALL PutC
	inc hl
	ex de,hl
	pop hl
	ld a,(hl)
	or a
	jp z,Custom_Display_Loop_None
	cp 0FCh
	jr nc,Custom_Display_Loop_Two
	push de
	ld d,0
	ld e,(hl)
	inc hl
	inc hl
	push hl
	B_CALL KeyToString
	B_CALL PutPSB
	pop hl
	pop de
	pop bc
	xor a
	ld (curcol),a
	ld a,(currow)
	inc a
	ld (currow),a
	djnz Custom_Display_Loop
	jr Custom_Main
Custom_Display_Loop_Two:
	push de
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	push hl
	B_CALL KeyToString
	B_CALL PutPSB
	pop hl
	pop de
Custom_Display_Loop_JumpIn:
	pop bc
	xor a
	ld (curcol),a
	ld a,(currow)
	inc a
	ld (currow),a
	djnz Custom_Display_Loop
Custom_Main:
	call Custom_Select
Custom_Main_Loop:
	B_CALL GetKey
	cp kEnter
	jr z,CustomMenu_Enter
	cp kDown
	jp z,CustomMenu_MoveDown
	cp kUp
	jr z,CustomMenu_MoveUp
	cp kDel
	jr z,CustomMenu_Clear
	cp k1
	call nc,CustomMenu_Numeric
	ld hl,Menu_SpecialKeys
	ld c,(hl)
	inc hl
	ld b,0
	cpir
	jr nz,Custom_Main_Loop
	or a
	ret
CustomMenu_Clear:
	ld hl,CatalogAppVar
	rst 20h
	B_CALL ChkFindSym
	ex de,hl
	inc hl
	inc hl
	ld a,(cur_row)
	add a,a
	ld d,0
	ld e,a
	add hl,de
	ld (hl),0
	inc hl
	ld (hl),0
	jp Hook_Key_Vars_OK
CustomMenu_Numeric:
	cp k8+1
	ret nc
	sub k1
	ld (cur_row),a
CustomMenu_Enter:
	ld a,1
	ld (tokenHookPtr+3),a
	ld hl,CatalogAppVar
	rst 20h
	B_CALL ChkFindSym
	ex de,hl
	inc hl
	inc hl
	;HL is start of data
	ld a,(cur_row)
	add a,a
	ld d,0
	ld e,a
	add hl,de
	ld a,(hl)
	or a
	jr z,CustomMenu_Enter_Empty
	ld (ramCode),a
	inc hl
	ld a,(hl)
	ld (ramCode+1),a
	ld a,sk5
	ld (kbdscancode),a
	ld a,kClear
	or a
	res cmdVirgin,(iy+cmdFlags)
	ret
CustomMenu_Enter_Empty:
	xor a
	ld (tokenHookPtr+3),a
ClearAndExit:
	ld a,kClear
	or a
	ret
CustomMenu_MoveUp:
	call Custom_Unselect
	ld a,(cur_row)
	or a
	jr z,CustomMenu_MoveUp_Down
	dec a
	ld (cur_row),a
	call Custom_Select
	jp Custom_Main_Loop
CustomMenu_MoveUp_Down:
	ld a,7
	ld (cur_row),a
	call Custom_Select
	jp Custom_Main_Loop
CustomMenu_MoveDown:
	call Custom_Unselect
	ld a,(cur_row)
	cp 7
	jr z,CustomMenu_MoveDown_Up
	inc a
	ld (cur_row),a
	call Custom_Select
	jp Custom_Main_Loop
CustomMenu_MoveDown_Up:
	xor a
	ld (cur_row),a
	call Custom_Select
	jp Custom_Main_Loop
Custom_Display_Loop_None:
	inc hl
	inc hl
	jp Custom_Display_Loop_JumpIn
Custom_Select:
	ld a,(cur_row)
	ld (currow),a
	ld hl,Entries_List
	add a,a
	ld d,0
	ld e,a
	add hl,de
	xor a
	ld (curcol),a
	set textInverse,(iy+textFlags)
Custom_Toggle:
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,(hl)
	B_CALL PutC
	res textInverse,(iy+textFlags)
	ret
Custom_Unselect:
	ld a,(cur_row)
	ld (currow),a
	ld hl,Entries_List
	add a,a
	ld d,0
	ld e,a
	add hl,de
	xor a
	ld (curcol),a
	jr Custom_Toggle
Hook_Key_Custom_Second:
	ld a,(tokenHookPtr+3)
	dec a
	jr nz,Custom_Key_Second_No
	ld (tokenHookPtr+3),a
	ld a,(ramCode)
	cp 0FCh
	jr nc,Custom_Key_Second_Two
	pop bc
	or a
	ret
Custom_Key_Second_Two:
	ld a,(ramCode+1)
	ld (keyExtend),a
	ld a,(ramCode)
	cp 0FFh
	call z,Custom_Key_Second_Dec
	cp 0FDh
	call z,Custom_Key_Second_Dec
	pop bc
	or a
	ret
Custom_Key_Second_Dec:
	dec a
	ret
Custom_Key_Second_No:
	ld a,k5
	or a
	ret
CreateCustomAppVar:
	ld de,(iMathPtr1)
	push de
	B_CALL CloseEditEqu
	ld hl,16
	B_CALL CreateAppVar
	pop de
	B_CALL EditProg
	set editOpen,(iy+editFlags)
	ld hl,(iMathPtr1)
	inc hl
	inc hl
	ld (editTop),hl
	ld hl,(iMathPtr2)
	ld (editCursor),hl
	ex de,hl
	ld hl,(iMathPtr3)
	B_CALL CpHLDE
	jr nc,SetupEditProgSwapSkip2
	ex de,hl
SetupEditProgSwapSkip2:
	ld (editBtm),hl
	ld (editTail),hl
	ld hl,CatalogAppVar
	rst 20h
	B_CALL ChkFindSym
	ret
Hook_Key_Base:
	in a,(4)
	bit 3,a
	jr nz,Hook_Key_Base_Ret
	call GetRealSettings
	bit 6,(hl)
	jr z,Hook_Key_Base_Ret
	;Get two digit base
Hook_Key_Base_Loop:
	B_CALL GetCSC
	or a
	jr z,Hook_Key_Base_Loop
	ld hl,Hook_Key_Base_Table1
	ld bc,4
	cpir
	jr nz,Hook_Key_Base_RetNo
	;Found first base
	ld de,3
	add hl,de
	ld a,(hl)
	ld (newbase),a
Hook_Key_Base_Loop2:
	B_CALL GetCSC
	or a
	jr z,Hook_Key_Base_Loop2
	ld hl,Hook_Key_Base_Table2
	ld bc,10
	cpir
	jr nz,Hook_Key_Base_RetNo
	ld de,9
	add hl,de
	ld a,(hl)
	ld b,a
	ld a,(newbase)
	add a,b
	ld (newbase),a
	cp 37
	jr nc,Hook_Key_Base_RetNo
	cp 2
	jr c,Hook_Key_Base_RetNo
	call GetRealSettings
	inc hl
	inc hl
	ld a,(newbase)
	ld (hl),a
	xor a
	ret
Hook_Key_Base_Table1:
	DB sk0,sk1,sk2,sk3
	DB 0,10,20,30
Hook_Key_Base_Table2:
	DB sk0,sk1,sk2,sk3,sk4,sk5,sk6,sk7,sk8,sk9
	DB 0,1,2,3,4,5,6,7,8,9
Hook_Key_Base_Ret:
	ld a,kLog
	or a
	ret
Hook_Key_Base_RetNo:
	xor a
	ret
