; Omnicalc v1.10
; (C) 2002-2003 Michael Vincent.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Adjust:
	call GetRealSettings
	ld (settingbyte),hl
	ld a,1
	ld (settingplace),a
Adjust_Initialize:
	B_CALL ClrLCDFull
	B_CALL GrBufClr
	res plotloc,(iy+plotflags)
	set textwrite,(iy+sgrflags)
	set bufferonly,(iy+plotflags)
	call Adjust_DisplayScreen
	B_CALL GrBufCpy
	res bufferonly,(iy+plotflags)
	res textwrite,(iy+sgrflags)
	call Adjust_ShowPointer
Adjust_Loop:
	ei
	halt
	B_CALL GetCSC
	cp sk2nd
	jr z,Adjust_Selected
	cp skEnter
	jr z,Adjust_Selected
	cp skUp
	jr z,Adjust_MoveUp
	cp skDown
	jr z,Adjust_MoveDown
	cp skClear
	jp z,MainMenu
	jr Adjust_Loop
Adjust_MoveUp:
	ld a,(settingplace)
	dec a
	jr z,Adjust_Loop
	call Adjust_ClearPointer
	ld hl,settingplace
	dec (hl)
	call Adjust_ShowPointer
	jr Adjust_Loop
Adjust_MoveDown:
	ld a,(settingplace)
	cp 7
	jr z,Adjust_Loop
	call Adjust_ClearPointer
	ld hl,settingplace
	inc (hl)
	call Adjust_ShowPointer
	jr Adjust_Loop
Adjust_Selected:
	ld a,(settingplace)
	ld b,a
	ld a,00000001b
Adjust_Selected_Loop:
	rlca
	djnz Adjust_Selected_Loop
	ld hl,(settingbyte)
	push af
	xor (hl)
	ld (hl),a
	pop af
	and (hl)
	jr z,Adjust_Selected_Clear
	ld a,(settingplace)
	ld b,a
	ld a,-8
Adjust_Selected_FillLoop:
	add a,9
	djnz Adjust_Selected_FillLoop
	ld h,a
	ld l,1
	add a,5
	ld d,a
	ld e,6
	B_CALL FillRect
	jp Adjust_Loop
Adjust_Selected_Clear:
	ld a,(settingplace)
	ld b,a
	ld a,-8
Adjust_Selected_ClearLoop:
	add a,9
	djnz Adjust_Selected_ClearLoop
	ld h,a
	ld l,1
	add a,5
	ld d,a
	ld e,6
	B_CALL DrawRectBorderClear
	jp Adjust_Loop
Adjust_ShowPointer:
	ld a,(settingplace)
	ld b,a
	ld a,-9
Adjust_ShowPointer_Loop:
	add a,9
	djnz Adjust_ShowPointer_Loop
	ld (penrow),a
	ld a,11
	ld (pencol),a
	ld a,05h
	B_CALL VPutMap
	ret
Adjust_ClearPointer:
	ld a,(settingplace)
	ld b,a
	ld a,-9
Adjust_ClearPointer_Loop:
	add a,9
	djnz Adjust_ClearPointer_Loop
	ld (penrow),a
	ld a,11
	ld (pencol),a
	ld a,06h
	B_CALL VPutMap
	ret
Adjust_DisplayScreen:
	ld hl,Adjust_Screen_1
Adjust_DisplayScreen_Ready:
	ld de,16
	ld (pencol),de
	ld b,7
Adjust_DisplayScreen_Ready_Loop:
	push bc
	call vputstr
	ld a,16
	ld (pencol),a
	ld a,(penrow)
	add a,9
	ld (penrow),a
	pop bc
	djnz Adjust_DisplayScreen_Ready_Loop
	ld a,1
	ld (penrow),a
	ld b,7
Adjust_DisplayScreen_Boxes:
	push bc
	ld a,(penrow)
	ld h,a
	ld l,1
	add a,5
	ld d,a
	ld e,6
	B_CALL DrawRectBorder
	ld a,(penrow)
	add a,9
	ld (penrow),a
	pop bc
	djnz Adjust_DisplayScreen_Boxes
	ld hl,(settingbyte)
	ld b,7
	ld a,1
	ld (penrow),a
Adjust_DisplayScreen_Boxes_Loop:
	ld a,00000001b
	push bc
Adjust_DisplayScreen_Boxes_SubLoop:
	rrca
	djnz Adjust_DisplayScreen_Boxes_SubLoop
	pop bc
	and (hl)
	jr z,Adjust_DisplayScreen_Boxes_SkipOne
	push hl
	push bc
	ld a,(penrow)
	ld h,a
	ld l,1
	add a,5
	ld d,a
	ld e,6
	B_CALL FillRect
	pop bc
	pop hl
Adjust_DisplayScreen_Boxes_SkipOne:
	ld a,(penrow)
	add a,9
	ld (penrow),a
	djnz Adjust_DisplayScreen_Boxes_Loop
	set fullscrndraw,(iy+apiflg4)
	ret
Adjust_Screen_1:
	DB "Parentheses  Assistant",0
	DB "Memory  Protection",0
	DB "Entries  Menu",0
	DB "RAM  Recovery  (SE  only)",0
	DB "Virtual  Calc  (SE  only)",0
	DB "Base  Conversion",0
	DB "Lowercase  Letters",0
FontSets:
	xor a
	ld (numsets),a
	ld hl,(progPtr)
FontSets_FirstLookLoop:
	ld bc,(pTemp)
	or a
	sbc hl,bc
	jr c,FontSets_FirstLook_Done
	jr z,FontSets_FirstLook_Done
	add hl,bc
	ld a,(hl)
	cp ProtProgObj
	jr nz,FontSets_FirstLook_Next
	;HL is at type byte
	push hl
	dec hl
	dec hl
	dec hl
	dec hl
	dec hl
	ld a,(hl)
	or a
	jr nz,FontSets_FirstLook_Nope
	inc hl
	inc hl
	ld a,(hl)
	dec hl
	ld h,(hl)
	ld l,a
	;HL is data (size bytes) now
	ld de,FontSet_Check
	ld b,13
	call CompareStrings
	jr nz,FontSets_FirstLook_Nope
	ld a,(numsets)
	inc a
	ld (numsets),a
	dec a
	add a,a
	ld d,0
	ld e,a
	ld hl,numsets+1
	add hl,de
	;store pointer to type byte
	pop de
	push de
	ld (hl),e
	inc hl
	ld (hl),d
FontSets_FirstLook_Nope:
	pop hl
FontSets_FirstLook_Next:
	ld de,-6
	add hl,de
	ld d,0
	ld e,(hl)
	inc e
	or a
	sbc hl,de
	jr FontSets_FirstLookLoop
FontSets_FirstLook_Done:
	;See if we found any
	ld a,(numsets)
	or a
	jp z,FontSets_NoSets
	;Main routine here, we found at least one font set (woohoo!)
	dec a
	add a,a
	ld d,0
	ld e,a
	ld hl,numsets+1
	add hl,de
	ld (setsend),hl
	ld hl,numsets+1
	ld (setpointer),hl
	ld a,'A'
	ld (curchar),a
	B_CALL ClrLCDFull
	B_CALL GrBufClr
	ld hl,0
	ld de,7*256+95
	B_CALL FillRect
	set textInverse,(iy+textFlags)
	ld hl,30
	ld (pencol),hl
	ld hl,FontSets_Title
	call vputstr
	res textInverse,(iy+textFlags)
	call FontSets_Display
	call FontSets_Status
FontSets_MainLoop:
	ei
	halt
	B_CALL GetCSC
	cp skLeft
	jp z,FontSets_MoveLeft
	cp skRight
	jr z,FontSets_MoveRight
	cp skUp
	jr z,FontSets_MoveUp
	cp skDown
	jr z,FontSets_MoveDown
	cp skEnter
	jr z,FontSets_Toggle
	cp sk2nd
	jr z,FontSets_Toggle
	cp skClear
	jr z,FontSets_Save
	jr FontSets_MainLoop
FontSets_Save:
	ld hl,(setpointer)
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;HL now points to type byte
	ld de,-6
	add hl,de
	ld b,(hl)
	dec hl
	ld de,OP3+1
FontSets_Save_Loop:
	ld a,(hl)
	ld (de),a
	inc de
	dec hl
	djnz FontSets_Save_Loop
	ld a,6
	ld (OP3),a
	call GetRealSettings
	ld de,4
	add hl,de
	ex de,hl
	ld hl,OP3
	ld bc,9
	ldir
	;fontHookPtr+3 - lower byte
	;cxMainHookPtr+3 - upper byte
	xor a
	ld (fontHookPtr+3),a
	ld (cxMainHookPtr+3),a
	jp MainMenu
FontSets_MoveUp:
	ld hl,curchar
	dec (hl)
	call FontSets_PreviewChar
	jr FontSets_MainLoop
FontSets_MoveDown:
	ld hl,curchar
	inc (hl)
	call FontSets_PreviewChar
	jr FontSets_MainLoop
FontSets_Toggle:
	call GetRealSettings
	inc hl
	inc hl
	inc hl
	bit 0,(hl)
	jr nz,FontSets_Toggle_Off
	set 0,(hl)
	call FontSets_Status
	jp FontSets_MainLoop
FontSets_Toggle_Off:
	res 0,(hl)
	res FontHook,(iy+Hooks2)
	call FontSets_Status
	jp FontSets_MainLoop
FontSets_MoveRight:
	ld hl,(setpointer)
	ld de,(setsend)
	or a
	sbc hl,de
	jp z,FontSets_MainLoop
	ld hl,(setpointer)
	inc hl
	inc hl
	ld (setpointer),hl
	call FontSets_Display
	jp FontSets_MainLoop
FontSets_MoveLeft:
	ld hl,(setpointer)
	ld de,numsets+1
	or a
	sbc hl,de
	jp z,FontSets_MainLoop
	ld hl,(setpointer)
	dec hl
	dec hl
	ld (setpointer),hl
	call FontSets_Display
	jp FontSets_MainLoop
FontSets_Display:
	ld hl,0*256+2
	ld (currow),hl
	ld hl,(setpointer)
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld de,-6
	add hl,de
	ld b,(hl)
	dec hl
FontSets_Display_Loop:
	push bc
	ld a,(hl)
	B_CALL PutC
	dec hl
	pop bc
	djnz FontSets_Display_Loop
	B_CALL EraseEOL
	;Now display sample character
FontSets_PreviewChar:
	ld hl,OP4
	ld (hl),7
	inc hl
	ld (hl),8
	inc hl
	ex de,hl
	push de
	ld hl,(setpointer)
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;HL points to type byte
	dec hl
	dec hl
	dec hl
	ld a,(hl)
	dec hl
	ld h,(hl)
	ld l,a
	;HL points to size bytes
	ld de,13
	add hl,de
	push hl
	ld h,0
	ld a,(curchar)
	ld l,a
	ld e,l
	ld d,h
	add hl,hl
	add hl,hl
	add hl,hl
	or a
	sbc hl,de
	ex de,hl
	pop hl
	add hl,de
	;HL is font data now
	pop de
	ld bc,7
	ldir
	ld hl,OP4
	ld de,57*256+7
	B_CALL DisplayImage
	ld hl,FontSets_Preview_Title
	ld de,49*256
	ld (pencol),de
	jp vputstr
FontSets_Preview_Title:
	DB "Preview:",0
FontSets_Status:
	call GetRealSettings
	inc hl
	inc hl
	inc hl
	bit 0,(hl)
	jr nz,FontSets_Status_On
	ld hl,29*256+2
	ld de,35*256+8
	B_CALL DrawRectBorderClear
	ld de,29*256+12
	ld (pencol),de
	ld hl,FontSets_Question
	jp vputstr
FontSets_Status_On:
	ld hl,29*256+2
	ld de,35*256+8
	B_CALL FillRect
	ld de,29*256+12
	ld (pencol),de
	ld hl,FontSets_Question
	jp vputstr
FontSets_Title:
	DB "FONT  SETS",0
FontSets_Question:
	DB "Font set active?",0
FontSets_NoSets:
	B_CALL ClrLCDFull
	B_CALL GrBufClr
	ld hl,14*256+17
	ld (pencol),hl
	call DisplayMessageBox
	ld hl,FontSets_None
	call vputstr
	ld de,30*256+17
	ld (pencol),de
	call vputstr
FontSets_NoSets_Pause:
	ei
	halt
	B_CALL GetCSC
	or a
	jr z,FontSets_NoSets_Pause
	jp MainMenu
FontSets_None:
	DB "No font sets found.",0
	DB "Press any key",0
FontSet_Check:
	DW 1803
	DB 0BBh,06Dh,0C9h,"omnicalc"
